/* travail2.cpp : Ce fichier contient la fonction 'main'.L'exécution du programme commence et se termine à cet endroit.
Auteurs: Léanne Emond Maheux (EMOL74530409), Lily Occhibelli (OCCL72360500), Océane Rakotoarisoa (RAKO77350500)
Date: 27/11/23
Cours: SIF1053 Gr 01
*/

// Pour que Visual Studio compile le code avec "scanf"
#define _CRT_SECURE_NO_WARNINGS

// Fichiers .h requis
#include "stdio.h"
#include "conio.h"
#include "stdlib.h"

// Prototype de la fonction division
unsigned int division(unsigned int a, unsigned int b);

void main()
{
	/*
	main:
	- Point d'entrée du programme
	- Calcule la division et le reste N fois (spécifié par l'utilisateur
	- Ouvre/créé un fichier reponse.txt pour emmagasiner les réponses

	ENTRÉE: aucune
	SORTIE: aucune
*/
	unsigned int i, a, b, d, N;
	unsigned short c;
	FILE* rep; // initialization du pointeur qui contiendra le fichier
	rep = fopen("reponse.txt", "w"); // ouverture ou création du fichier reponse
	printf("Entrer le nombre de division a effectuer\n");
	scanf("%i", &N);
	while (N < 1 || N > 65535) { // vérification que l'entrée soit dans l'intervalle [1,65535]
		printf("Entree invalide. Entrer un nombre de division entre 1 et 65535.\n");
		scanf("%i", &N);
	}
	printf("Entrer la ou les divisions a effectuer de la facon suivante: a/b\n");
	for (i = 1; i <= N; i++) { // répéter la division N fois
		scanf("%i / %i", &a, &b);
		while (a < 0 || a > 65535 || b < 1 || b> 65535) { // vérification que a soit dans [0,65535] et b [1,65535]
			scanf("%i / %i", &a, &b);
		}
		d = division(a, b); // contient le quotient *et* le reste
		c = unsigned short(d); // isole le quotient, partie haute
		d = (d >> 16); // isole le reste, partie basse 
		fprintf(rep, "Division %i: %i/%i = %d reste %i\n", i, a, b, c, d); // écrit les réponses dans le fichier
	}
	fclose(rep); // fermeture du fichier
	system("start reponse.txt");
}

unsigned int division(unsigned int a, unsigned int b) {

	/*
	division:
	- Permet la division avec seulement l'addition, la soustraction et l'opération de décalage
	- Pour deux nombres signés int de 16 bits
	- a doit être compris entre [0,65535] et b dans [1,65535]

	ENTRÉE: unsigned int a (dividende), unsigned int b (diviseur)
	SORTIE: unsigned int a (quotient dans partie haute, reste dans partie basse)
*/
	b = b << 16;
	for (int i = 0; i < 16; i++) {
		a = a << 1;
		if (a >= b) {
			a -= b;
			a += 1;
		}
	}
	return a;
}