#include "stdafx.h"

// Fonction de division
unsigned int division(unsigned int dividend, unsigned int divisor, unsigned int *remainder) {
    unsigned int quotient = 0;
    *remainder = 0;
// La boucle suivante est utilisée pour effectuer la division de 16 bits en utilisant l'algorithme de division

    for (int i = 15; i >= 0; i--) {
            // On déplace le reste d'une position à gauche et on ajoute le bit de poids faible du dividende

        *remainder = (*remainder << 1) | ((dividend >> i) & 1);
        // Si le reste est supérieur ou égal au diviseur, on soustrait le diviseur du reste et on ajoute 1 au quotient
        if (*remainder >= divisor) {
            *remainder -= divisor;
            quotient |= (1u << i);
        }
    }

    return quotient;
}

int main(){ //travail fais Oumar Al Hassane Dia(DIAO90320400)//
    FILE *file = fopen("resultats.txt", "w");

    if (file == NULL) {
        fprintf(stderr, "Erreur lors de l'ouverture du fichier.");
        return 1;
    }

    int nombreDivisions;
    printf("Entrez le nombre de divisions à effectuer : ");
    scanf("%d", &nombreDivisions);

    for (int i = 1; i <= nombreDivisions; i++) {
        unsigned int dividend, divisor, remainder;
        printf("Division %d: Entrez le dividende (entre 0 et 65535) : ", i);
        scanf("%u", &dividend);

        printf("Division %d: Entrez le diviseur (entre 1 et 65535) : ", i);
        scanf("%u", &divisor);

        unsigned int quotient = division(dividend, divisor, &remainder);

        fprintf(file, "Division %d: %u / %u = %u reste %u\n", i, dividend, divisor, quotient, remainder);
    }

    fclose(file);

    printf("Les résultats ont été écrits dans le fichier 'resultats.txt'.\n");

    return 0;
}
