/********************************************************************
// TP2 Auteurs: Yannick Lemire 		LEMY14307400 groupe 01
//              Gabriel Levasseur   LEVG92080300
//              Derek Stevens       STED71290300
//
// Objectifs: Programme en langage C qui effectue la division de nombres entiers positifs de 16 bits. Vous devez implanter la mthode de division binaire par restauration des restes
// partiels en utilisant que les oprations d'addition, de soustraction et de dcalage.L'usager doit introduire au clavier le nombre de divisions  effectuer et pour chaque
// division introduire la valeur du dividende (entre 0 et 65535) et du diviseur (entre 1 et 65535).Les rsultats de chaque division tant la valeur du quotient (partie basse de la valeur retourne
// par la fonction division(), valeur entre 0 et 65535) et la valeur du reste  (partie haute de la valeur retourne par la fonction division(), valeur entre 0 et 65535) sera crit dans un
// fichier texte(reponse.txt) avec la forme suivante:
// Division 1: 1024 / 2 =  512 reste 0
// Division 2: 34/3 = 11 reste 1
// Division 3: 11/5= 2 reste 1
// Date : 2023-11-10
//********************************************************************/
#include <string.h>
#include <stdio.h>
unsigned int division(unsigned int,unsigned int);

// Fonction : Principale qui demande  l'usager d'entrer des valeurs et qui appelle la fonction de division sur ces nombres et les affiches
// Input : aucun
// Output: Retourne 0
int main()
{
    unsigned int num1, num2, reste, result, i;
    unsigned short nbredeDiv, retVal, resultFin;
    FILE *rep;

    rep= fopen("reponse.txt","w+"); // ouverture du fichier
    if (rep == NULL) { // Verifie si l'ouverture du fichier est un succes
		printf("Error! Impossible d'ouvrir le fichier!");
	}
	else {
	    printf(" \n Veuillez entrer le nombre de division a faire :");
        scanf("%i", &nbredeDiv); // capture l'entree clavier
        for(i=0; i<nbredeDiv;i++){ // boucle pour le nombre de division

            do{ // Boucle pour l'entree des donnees
                printf(" \n Veuillez entrer la ou les divisions a faire sous le format a/b:\n");
                scanf("%i/%i", &num1, &num2);// capture l'entree clavier les 2 chiffres de la division
                if ((num1 < 65535) && (num2 < 65535) && (num1 >= 0) && (num2 > 0)){ // verifie si le chiffre est valide

                    result = division(num1,num2); // fait la division
                    resultFin = (unsigned short)result; // Tronque les 32 bits pour ne prendre que les 16 LSB du unsigned integer
                    reste = (result >> 16); // va chercher le restant stocke dans les 16 bits du haut du unsigned integer
                    fprintf(rep,"\nDivision %d: %i / %i = %d reste %i", i, num1, num2, resultFin, reste); // Affiche le rsultat
                    retVal = 0; //  Set la valeur pour sortir de la boucle
                }
                else{
                    printf("\nNombre entre invalide, il doit etre entre 0 et 65535, recommencez"); // Mauvaise entree de clavier
                    retVal = 1; // Set la valeur pour recommencer la boucle
                }
            }while(retVal != 0);
        }
	}
    fclose(rep); // fermeture du Stream rep
    return 0;
}
// Fonction : Qui divise 2 nombres en utilisant des soustractions et des dcalages pour pouvoir stocker le restant dans les bits du haut
// Input : 2 unsigned int que l'on doit diviser
// Output: Le rsultat de la division en format unsigned integer
unsigned int division(unsigned int a, unsigned int b){
    int i=0;
    b= b<<16; // Decalage de 16 bit pour mettre la valeur dans les 16 BLPS
    for(i=0;i<=15;i++){ // Boucle a travers les 16 bits composant le u int
        a = a << 1; // Dcalage de la matrice au final de 16 bit vers la gauche
        if(a>=b){ // le dividende peut etre encore divise
            a = a-b; // Dividende - diviseur
            a += 1; // Ajoute un
        }
    }
    return a; // Quotient dans les 16 BLMS et le restant dans les 16 BLPS
}
