// Auteur : Leandre Steve Mbakop Tsafack , Isaac Olivier Junior Traore

#include <stdio.h>

// Dfinition de la mthode
/* Fonction qui fait la division des nombres binaires  16 bits */
unsigned int divisionBinaire(unsigned int dividende, unsigned int diviseur) {
    int quotient = 0;
    int decalage = 1;

    // Recherche du plus grand dcalage possible pour la division
    while (diviseur <= dividende) {
        diviseur = diviseur << 1;
        decalage++;
    }

    decalage--;

    // Division binaire
    while (decalage >= 0) {
        if (dividende >= diviseur) {
            dividende -= diviseur;
            quotient |= (1 << decalage);
        }

        diviseur = diviseur >> 1;
        decalage--;
    }

    // Affichage du reste dans la console
    printf("Reste : %u\n", dividende);
    return quotient;
}

int main() {
    unsigned int dividende;
    unsigned int diviseur;

    FILE *file;
    // Ouverture du fichier en mode criture
    file = fopen("Untitled1.txt", "w");

    // Gestion d'erreur en cas d'chec de l'ouverture du fichier
    if (file == NULL) {
        perror("Error opening file");
        return 1;
    }

    // Demande  l'utilisateur d'entrer le dividende
    printf("Entrer le dividende (0 a 65355) : ");
    scanf("%u", &dividende);
    // criture du dividende dans le fichier
    fprintf(file, "Dividende : %u\n", dividende);

    // Demande  l'utilisateur d'entrer le diviseur
    printf("Entrer le diviseur (0 a 65355) : ");
    scanf("%u", &diviseur);
    // criture du diviseur dans le fichier
    fprintf(file, "Diviseur : %u\n", diviseur);

    // Vrification si le diviseur est nul
    if (diviseur == 0) {
        // criture de l'erreur dans le fichier et fermeture du fichier
        fprintf(file, "Erreur: La division ne peut pas etre zero.\n");
        fclose(file);
        return 1;
    }

    // Appel de la fonction de division binaire
    unsigned int result = divisionBinaire(dividende, diviseur);

    // criture du quotient dans le fichier
    fprintf(file, "Quotient : %u\n", result);
    // Affichage du quotient dans la console
    printf("Quotient : %u\n", result);

    // Fermeture du fichier
    fclose(file);
    return 0;
}
