/* Auteur :
groupe 01 Mercredi
Serigne Fallou ngom
Diariatou sow
Djiaha Kouega Marcy Audrey
Chamko Itendji Victoire Shiphra */
#include <stdio.h>

// Fonction de division binaire par restauration des restes partiels
unsigned int division(unsigned int dividend, unsigned int divisor, unsigned int *remainder) {
    // Initialisation des variables
    unsigned int quotient = 0;
    *remainder = 0;
       int i ;
    // Itration pour chaque bit du dividende
    for ( i = 15; i >= 0; i--) {
        // Dcalage vers la gauche du reste
        *remainder = (*remainder << 1) | ((dividend >> i) & 1);

        // Soustraction du diviseur du reste
        if (*remainder >= divisor) {
            *remainder -= divisor;
            quotient = (quotient << 1) | 1;
        } else {
            quotient = quotient << 1;
        }
    }

    return quotient;
}

// Fonction pour afficher les rsultats d'une division dans un fichier
void afficherResultats(FILE *file, int index, unsigned int dividend, unsigned int divisor, unsigned int quotient, unsigned int remainder) {
    fprintf(file, "Division %d : %u / %u = %u reste %u\n", index, dividend, divisor, quotient, remainder);
}

int main() {
    int numDivisions;

    // Demander le nombre de divisions  l'utilisateur
    printf("Entrez le nombre de divisions a effectuer : ");
    scanf("%d", &numDivisions);

    // Ouvrir le fichier pour crire les rsultats
    FILE *file = fopen("resultats.txt", "w");
    if (file == NULL) {
        printf("Erreur lors de l'ouverture du fichier.\n");
        return 1;
    }
        int i ;
    // Effectuer les divisions demandes
    for ( i = 1; i <= numDivisions; i++) {
        unsigned int dividend, divisor, remainder, quotient;

        // Demander les valeurs du dividende et du diviseur  l'utilisateur
        printf("Division %d : Entrez le dividende (entre 0 et 65535) : ", i);
        scanf("%u", &dividend);
        printf("Division %d : Entrez le diviseur (entre 1 et 65535) : ", i);
        scanf("%u", &divisor);

        // Vrifier si le diviseur est gal  0
        if (divisor == 0) {
            printf("Erreur : Le diviseur ne peut pas tre gal  0.\n");
            fclose(file);
            return 1;
        }

        // Appeler la fonction de division
        quotient = division(dividend, divisor, &remainder);

        // Afficher les rsultats dans le fichier et  l'cran en utilisant la fonction ddie
        afficherResultats(file, i, dividend, divisor, quotient, remainder);
        afficherResultats(stdout, i, dividend, divisor, quotient, remainder);
    }

    // Fermer le fichier
    fclose(file);



    return 0;
}
