//Devoir2.c         Author: Cheikh Tidiane Diakhaté
//                          Khady Loum
//                          Daour Top
//                          Cheikh Diakhaté

#include "tp2.h"

/*Cette fonction met en œuvre l'algorithme de division binaire par restauration des restes partiels, 
    en calculant le quotient et le reste. Elle utilise le pointeur pour stocker 
    la valeur du reste en passant une opération bit à bit.*/

unsigned int division(unsigned int dividende, unsigned int diviseur, unsigned int *reste) {
    unsigned int quotient = 0;
    *reste = 0;

    for (int i = 15; i >= 0; i--) {
        *reste = (*reste << 1) | ((dividende >> i) & 1);
        if (*reste >= diviseur) {
            *reste -= diviseur;
            quotient |= (1 << i);
        }
    }

    return quotient;
}
